﻿Type=Service
Version=3.8
B4A=true
@EndOfDesignText@
#Region Module Attributes
	#StartAtBoot: False
#End Region

'Service module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
Dim Recheck As Boolean
End Sub
Sub Service_Create

End Sub

Sub Service_Start (StartingIntent As Intent)

'NOTE!! ALWAYS check phone first! We will ALWAYS turn it OFF there if there is no entry, and turn it back on
'in SMS IF needed. But we will NEVER turn it OFF in CheckSMSLog
'NOTE we are checking SMS because a message MIGHT come in while on the phone?
If NagMod.smgr.GetBoolean("NagPhone") Then CheckPhLog
If NagMod.smgr.GetBoolean("NagText") Then CheckSMSLog

End Sub

Sub Service_Destroy
If Recheck = True Then StartServiceAt("CheckPhoneLog",DateTime.Now + 1000, True)
End Sub

Sub RestartCheckLog
Dim NumTrys As Int
Try
	NumTrys = NagMod.smgr.getstring("NumTrys")
	'	Log("RestartCheckLog " & NagMod.smgr.getstring("NumTrys"))

	If NumTrys < 6 Then
		NagMod.smgr.SetString("NumTrys",NumTrys + 1)
	Else
		Recheck = False
	End If
	StopService("CheckPhoneLog")
Catch
	'Log("RestartCheckLog" & CRLF & LastException.Message)
	ToastMessageShow("CheckPhoneLog RestartCheckLog" & CRLF & LastException.Message,True)
End Try

End Sub


Private Sub CheckPhLog
Dim S As String  ', NT As Notification

Recheck = False

Try
	NagMod.MyList.Initialize
	'Log("From CheckPHLog" & DateTime.Now)
	NagMod.MyList = NagMod.CallLog.GetSince(NagMod.smgr.getstring("LastCallDate") + 1, 1) 'look for anything 1/1000th of a second newer than what we logged
	'Log("Checking Call Log by date, Date=" & DateTime.Date(NagMod.smgr.getstring("LastCallDate") + 1) & " : " & DateTime.time(NagMod.smgr.getstring("LastCallDate") + 1)) 
	If NagMod.MyList.Size > 0 Then
		NagMod.CC = NagMod.MyList.Get(0)
		If NagMod.CC.CallType = NagMod.CC.TYPE_MISSED Then
			'S= NagMod.smgr.GetString("Frequency")  '9/5/14 - Kim Remmed - extra?
			'If S.EqualsIgnoreCase("") = True Then S=60000  '9/5/14 - Kim Remmed - extra?
			'Log ("Start Notication ms = " & S)
			NagMod.smgr.setboolean("UsrIntervened",False)
			S = NagMod.smgr.GetString("Frequency")
			If S.EqualsIgnoreCase("") = True Then S = 60000 Else S = S
			'Log("From CheckPHLog")
			Recheck = False
			If NagMod.smgr.getboolean("Nagging") = False Then  '12/22/12
				StartServiceAt("SetNag",DateTime.Now + 1000,  True) 'Show the notification immediately so user can stop it now and not have to wait
				'ToastMessageShow("StartServiceAt(SetNag 3", True)   'Testing
				StartServiceAt("PlaySound",DateTime.Now + S,  True) 'No noise until time has passed
			End If
		Else If NagMod.CC.CallType=NagMod.CC.TYPE_OUTGOING Then 'we are active so turn off alarn
			'NagMod.smgr.setboolean("UsrIntervened",True)
			'StopService("SetNag")
			NagMod.KillAll(False)
		End If
	Else
		Recheck=True
		RestartCheckLog
	End If
Return
Catch
	ToastMessageShow("CheckPhoneLog CheckPhLog" & CRLF & LastException.Message,True)
	'Log("CheckPhLog error" & CRLF & LastException.Message)
End Try

End Sub

'SMS mesages, unlike the phone log are flagged as read or unread so we can look for that and turn off based on that
Public Sub CheckSMSLog
Dim SmsMessages1 As SmsMessages, Sms As Sms
Dim S As String  ', NT As Notification

Recheck = False

Try
	NagMod.MyList.Initialize
	NagMod.MyList = SmsMessages1.GetAllSince(NagMod.smgr.getstring("LastCallDate") + 1) 'look for anything 1/1000th of a second newer than what we logged
	If NagMod.MyList.Size > 0 Then
		Sms = NagMod.MyList.Get(0)  'Most recent
		If Sms.Read = False Then
			S= NagMod.smgr.GetString("Frequency")
			If S.EqualsIgnoreCase("") = True Then S=60000
			'Log ("Start Notication ms = " & S)
			NagMod.smgr.setboolean("UsrIntervened",False)
			S = NagMod.smgr.GetString("Frequency")
			If S.EqualsIgnoreCase("") = True Then S = 60000 Else S = S
			'Log("From CheckSMSLog")
			If NagMod.smgr.getboolean("Nagging") = False Then  '12/22/12
				StartServiceAt("SetNag",DateTime.Now + 1000,  True) 'Show the notification immediately so user can stop it now and not have to wait
				'ToastMessageShow("StartServiceAt(SetNag 1", True)   'Testing
				StartServiceAt("PlaySound",DateTime.Now + S,  True) 'No noise until time has passed
			End If
		Else If Sms.Read = True Then  'we have a later messsage that has been read so stop Nagging
			NagMod.KillAll(False)  'We have read a message since truning on so turn it off
		End If
	Else
		'Log("From CheckSMSLog")
		RestartCheckLog
	End If
Return
Catch
	ToastMessageShow("CheckPhoneLog CheckSMSLog" & CRLF & LastException.Message,True)
	'Log("CheckSMSLog error" & CRLF & LastException.Message)
End Try

End Sub