﻿Type=Class
Version=3.8
B4A=true
@EndOfDesignText@
'Class module
Private Sub Class_Globals

Private dr1,dr2,dr3 As GradientDrawable
Private slider, caret As ImageView
Private Vpos, H, W, MaxV, D As Int
Private Hmodule As Object
Public base As Panel
Private cover As Panel
Private BarName As String
End Sub

'Initializes the object. 
'Module is the launching module.

'11/27/12 added CaretLoc
Public Sub Initialize(Module As Object, Eventname As String, width As Int ,height As Int, MaxValue As Int, CaretLoc As String)
Try
	Hmodule = Module
	BarName = Eventname
	H = height
	W = width
	MaxV = MaxValue
	D = 20dip

	base.Initialize("")
	slider.Initialize("")
	base.AddView(slider,0,0,W,H)

	caret.Initialize("")
	'base.AddView(caret,W/4-D/2,0, D,H)
	base.AddView(caret,CaretLoc-D/2,0, D,H)    '11/27/12 added CaretLoc

	cover.Initialize("cover")
	base.AddView(cover,0,0,W,H)

	setColors(Colors.Black,Colors.white, Colors.Yellow, Colors.lightgray)
Catch
	'Log(LastException.Message)
	ToastMessageShow("HSeekBar Initialize" & CRLF & LastException.Message,True)
End Try
End Sub

'Sets the colors of the bar
Sub setColors(BackGround As Int,basecolor As Int,slidercolor As Int, caretcolor As Int)
Dim clr(3) As Int
Try
	clr = Array  As Int(BackGround,basecolor,BackGround)
	dr1.Initialize("TOP_BOTTOM",clr)
	base.BackGround =   dr1  ' .Initialize(basecolor,BackGround,False)
	clr = Array  As Int(BackGround,slidercolor,BackGround) 
	dr2.Initialize("TOP_BOTTOM",clr)
	slider.BackGround = dr2
	clr = Array  As Int(BackGround,caretcolor,BackGround) 
	dr3.Initialize("LEFT_RIGHT",clr)
	caret.BackGround =  dr3
Catch
	'Log(LastException.Message)
	ToastMessageShow("HSeekBar setColors" & CRLF & LastException.Message,True)
End Try

End Sub


Sub AsView As View
Return base
End Sub

' Sets the Max value of the bar 
Sub setMaxValue(Value As Int)
MaxV = Value
End Sub

'Sets the width of the caret.
'The default is 20dip.
Sub setCaretWidth(value As Int)
Try
	D = value
	caret.Width = D
	caret.left = Max(Min(W-D,slider.width-D/2),0)
Catch
	'Log(LastException.Message)
	ToastMessageShow("HSeekBar setCaretWidth" & CRLF & LastException.Message,True)
End Try

End Sub

Private Sub setPosition(Value As Int, userchanged As Boolean)
Try
	slider.width = Max(Min(W * Value/MaxV, W ),0)
	caret.left = Max(Min(W-D,slider.width-D/2),0)
	base.Invalidate
	If SubExists(Hmodule, BarName & "_ValueChanged") Then
	  CallSub3(Hmodule,BarName & "_ValueChanged", Value , userchanged )
	End If
Catch
	'Log(LastException.Message)
	ToastMessageShow("HSeekBar setPosition" & CRLF & LastException.Message,True)
End Try

End Sub

' Sets the value of the bar 
' ValueChanged event will be raised with Userchanged = false
Sub setValue(Value As Int)
Vpos = Value
setPosition(Vpos,False)
End Sub

' Returns the current value of the bar
Sub getValue As Int
Return Vpos
End Sub


Private Sub cover_Touch(Action As Int, X As Float, Y As Float) As Boolean 
Dim k As Int
Try
	k = X * MaxV / W
	k = Max(Min(k, MaxV),0)
	setPosition(k, True)
	Return True
Catch
	'Log(LastException.Message)
	ToastMessageShow("HSeekBar cover_Touch" & CRLF & LastException.Message,True)
	Return False
End Try

End Sub

