﻿Type=StaticCode
Version=3.8
B4A=true
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
Public MyList As List, CallLog As CallLog, CC As CallItem  ', CallType
Public smgr As PreferenceManager
'
Dim OFFHOOK As Int  'used as constants
 'cIDLE As Int, RINGING As Int
End Sub

Public Sub GetLastCall
'Dim S As String

Try
	MyList = CallLog.GetAll(1)
	If MyList.Size > 0 Then
		CC=MyList.Get(0)
		smgr.setstring("LastCallID", CC.id)
		smgr.setstring("LastCallDate", CC.Date)
		'Log("GetLastCall LasCall ID= " & CC.id)
	Else
		smgr.Setstring("LastCallID", 0)
		smgr.Setstring("LastCallDate", DateTime.Now)
	End If
Catch
	ToastMessageShow("GetLastCall Error" & CRLF & LastException.Message, True)
End Try

End Sub

Public Sub GetLastSMS
Dim SmsMessages1 As SmsMessages, Sms As Sms
Dim List1 As List
Try
	List1 = SmsMessages1.GetAllSince(DateTime.Add(DateTime.Now,  0, 0, -1))
	If List1.Size > 0 Then 
	    Sms = List1.Get(0)  'Most recent
		smgr.Setstring("LastSMSID", Sms.Id)
		smgr.Setstring("LastSMSDate", Sms.Date)
	Else
		smgr.Setstring("LastSMSID", 0)
		smgr.Setstring("LastSMSDate", DateTime.Now)
	End If
	'Log("ID " & smgr.Getstring("LastSMSID") & " " & smgr.Getstring("LastSMSDate") & "  " & DateTime.Time(smgr.Getstring("LastSMSDate")))
Catch
	ToastMessageShow("GetLastSMS Error" & CRLF & LastException.Message, True)
End Try

End Sub

'returns the current device call state
'0 = Device call state: No activity.
'1 = Device call state: Ringing. A new call arrived and is ringing or waiting. In the latter case, another call is already active.
'2 = Device call state: Off-hook. At least one call exists that is dialing, active, or on hold, and no calls are ringing or waiting.
Sub GetCallState() As Int    
Dim r As Reflector    
Dim TelephonyManager As Object
'Dim CS As String
'cIDLE = 0
'RINGING = 1
OFFHOOK = 2
Try
	r.Target = r.GetContext
	TelephonyManager = r.RunMethod2("getSystemService", "phone", "java.lang.String")
	r.Target = TelephonyManager
	Return r.RunMethod( "getCallState")
Catch
	ToastMessageShow("GetCallState Error" & CRLF & LastException.Message, True)
	Return 566
End Try

End Sub

'Sub GetRingTonePath() As Int    
'Dim r As Reflector    
'Dim Environment As Object
''Dim CS As String
'cIDLE = 0
'RINGING = 1
'OFFHOOK = 2
'Try
'	r.Target = r.GetContext
'	Environment = r.RunMethod2("getSystemService",  "phone", "java.lang.String")
'	r.Target = Environment
'	Return r.RunMethod( "getCallState")
'Catch
'	ToastMessageShow("GetRingTonePath Error" & CRLF & LastException.Message, True)
'	Return 0
'End Try
'
'End Sub

Sub KillAll(NotIcon As Boolean)
'Dim MInt As Int
Try
	'ToastMessageShow("KillAll" ,True)  'Testing
	smgr.Setboolean("UsrIntervened", True)
	CancelScheduledService("SetNag")
	StopService("PlaySound" )
	CancelScheduledService("PlaySound")
	StopService("CheckPhoneLog" )
	CancelScheduledService("CheckPhoneLog")
	StopService("DoNotification" )
	CancelScheduledService("DoNotification")
	StopService("DoSMSNotification" )
	CancelScheduledService("DoSMSNotification")
	If Not(NotIcon) Then 
		StopService("SetNag")
		DoNotification.nt.Cancel(1)
		SetNag.SetTimeStart = 0
		'ToastMessageShow("We are stopping and canceling" ,True)  'Testing
	End If 
	StopService("ScreenOnOff")
	smgr.Setboolean("Nagging", False)
Catch
	ToastMessageShow("There was an error stopping Nag" & CRLF & LastException.Message ,True)
	'Log("KillAll Error" & CRLF & LastException.Message)
End Try

End Sub


Public Sub FirstTimeinit
Dim H As Long
Try
	smgr.ClearAll
	smgr.Setboolean("StartAtBoot", True)
	smgr.SetBoolean("DoNotNag", False)
	smgr.SetString("Frequency","60000")   'TestXX should be 60000
	#If Test
		smgr.SetString("Frequency", 10000)
		smgr.SetString("TestTime", DateTime.Now + (DateTime.TicksPerMinute * 5))  'adds 5 min
	#End If
	smgr.SetString("FrequencySpin", "0")
	smgr.SetString("RingTimeSpin","2")
	smgr.SetString("RingTime","1500")
	smgr.Setboolean("NagPhone", True)
	smgr.Setboolean("NagText",True)
	smgr.SetBoolean("NagEmail", True)
	smgr.SetBoolean("Vibrate", True)
	smgr.SetBoolean("Ring", True)
	smgr.SetString("Volume",".75")
	smgr.SetString("NagRingtone","Nag Internal")
	GetLastCall
	GetLastSMS
	smgr.Setboolean("PhoneSilenced", False)
	smgr.SetString("LastSilencedPos", 7)
	smgr.Setboolean("VibrateWhenSilenced", False)
'	smgr.SetString("CaretLoc", NagSetup.SB1.Width*.75)
	smgr.setString("NagLength", DateTime.Now)  'Now so check happens immediately
	smgr.SetString("CheckToday", DateTime.Now + DateTime.TicksPerDay)   '12/18/13 - Kim
	smgr.setString("NagFailed", "")  'Added 10/23/13 we will set this to a date to allow retries if licensing fails
	smgr.setString("NagFailure", "")  'Added 10/23/13this is our flag that we have a real failure.
	'below are trial only
	H = GetLeast   'Trial Version
	SetTrialDate(H)   'Trial Version
Catch
	ToastMessageShow("There was an error setting defaults." & CRLF & LastException.Message,True)
End Try

End Sub

'10/5/14 - Everything below this line is trial only
Sub SetTrialDate(S As Long)
Dim H As String, Y As String
Dim MyFile As PublicFile, MP As Map, NumChecks As String

Y = S
H = Generate_Hash(Y)
smgr.SetString("LastSilencedVolume",  Y)
smgr.SetString("FirstMsgOpened",  H)
MP.Initialize
MP.Put(Y, H)
NumChecks = ""
If WriteMapToFile(File.DirRootExternal, MyFile.DirDownloads, "Android.Public", MP) Then NumChecks = "P"
If WriteMapToFile(File.DirRootExternal, MyFile.DirDocuments, "Android.DONOTDELETE.Doc", MP) Then NumChecks =  NumChecks & "D"
If WriteMapToFile(File.DirRootExternal, MyFile.DirDCIM, "Android.System.sav", MP) Then NumChecks =  NumChecks & "S"
If WriteMapToFile(File.DirRootExternal, MyFile.DirMovies, "Andro.sys.bin", MP) Then NumChecks =  NumChecks & "b"
smgr.SetString("NumChecks", NumChecks)
smgr.SetString("0Bal", NumChecks)

'•DirMovies
'•DirPictures
'•DirDocuments
'•DirDCIM
'•DirAlarms
'•DirMusic
'•DirNotifications
'•DirDownloads
'•DirPodcasts
'•DirRingtones

	End Sub

'Test our trial date. Validate the internal date against all externals
Sub TestTrialDate As Boolean
Dim S As Long, S2 As Long, H As String, Y As String, TestChecks As String
Try
	'These two should be the same, if they are not then someone is messing with our app
	TestChecks = smgr.GetString("NumChecks")
	If TestChecks <> smgr.GetString("0Bal") Then
		ToastMessageShow("Nag - Trial Data is Corrupt Trial Expired!", True)
		SetNag.SetTimeStart = 87
		Return False
	End If
	TestChecks = ""  '1014/14
	Y = smgr.GetString("LastSilencedVolume")
	H = Generate_Hash(Y)
	If H = smgr.GetString("FirstMsgOpened") Then
		'ToastMessageShow("Hashes Matched", False)
		S = Y 'convert our saved string to long
		'if Stored local data does not = installtime them there is an issue.
		S2 = DateTime.DateParse(DateTime.Date(GetFirstInstallTime("com.superlativesoftware.nagtrial"))) 
		If S > S2 Then ' It must have been tampered with
			ToastMessageShow("Nag - Trial Licensing has been tampered with. Trial Expired!", True)
			SetNag.SetTimeStart = 5
			Return False
		End If
		'We were unable to write ANY external files (so lets just try it again if our date is not expired
		If TestChecks.Length = 0 Then
					#If Rel
			If S + DateTime.TicksPerDay * ((2 * 3) + 5 + 4) < DateTime.Now Then
					#End If
					#If Test
			ToastMessageShow("Trial Install date is:" & DateTime.Date(S), True)
			If smgr.GetString("TestTime") < DateTime.Now Then 
				#End If
				ToastMessageShow("Nag - Trial License has Expired!", True)
				SetNag.SetTimeStart = 4
				Return False
			End If
			SetTrialDate(S2) 'try again to set externals
			S2 =  (S + DateTime.TicksPerDay * ((2 * 3) + 5 + 4) - DateTime.Now) / DateTime.TicksPerDay
			If S2 < 4 Then ToastMessageShow("Your Nag Trial expires in  " & S2 & " Days!" , True)
			Return True
		Else 'This is where we test our saves
			S  = GetLeast
					#If Rel
			If S + DateTime.TicksPerDay * ((2 * 3) + 5 + 4) < DateTime.Now Then
					#End if
					#If Test
			ToastMessageShow("Trial Install date is:" & DateTime.Date(S), True)
			If  smgr.GetString("TestTime") < DateTime.Now Then  'Trial Testing - Rem when done and unrem above
					#End If
				ToastMessageShow("Nag - Trial License has Expired!", True)
				SetNag.SetTimeStart = 3
				'Msgbox("Trial Expired", "")
				'CallSubDelayed("TrialExp",  "DoNothing")
				Return False
			Else
			 	If TestChecks.Length < 4 Then SetTrialDate(S) 
			End If
		End If
					#If Rel
			If S + DateTime.TicksPerDay * ((2 * 3) + 5 + 4) < DateTime.Now Then
					#End if
					#If Test
			ToastMessageShow("Trial Install date is:" & DateTime.Date(S), True)
			If  smgr.GetString("TestTime") < DateTime.Now Then  'Trial Testing - Rem when done and unrem above
					#End If
				ToastMessageShow("Nag - Trial License has Expired!", True)
				SetNag.SetTimeStart = 22
				Return False
			Else
			S2 =  (S + DateTime.TicksPerDay * ((2 * 3) + 5 + 4) - DateTime.Now) / DateTime.TicksPerDay
			If S2 < 4 Then ToastMessageShow("Your Nag Trial expires in  " & S2 & " Days!" , True)
				Return True
			End If
			ToastMessageShow("Unanticipated error, Nag - Trial License has Expired!", True)  'ignore
			SetNag.SetTimeStart = 14
			Return False
Else
		ToastMessageShow("Nag - Trial license information invalid!", True)
		SetNag.SetTimeStart = 5
		Return False
	End If 
Catch
	ToastMessageShow("Nag - Trial license information invalid!" & CRLF & LastException.Message, True)
	SetNag.SetTimeStart = 127
	Return False
End Try

End Sub

Sub Generate_Hash(Hashit As String) As Long
  Dim Prime As Long : Prime = 1125899906842597
  Dim cntr As Int 
  Dim ReturnHash As Long
Try
  For cntr = 0 To Hashit.Length - 1
     ReturnHash = ReturnHash+31*Prime + Asc(Hashit.CharAt(cntr))
   Next
  Return ReturnHash
Catch
	'Log("Error in Generate_Hash" & LastException.Message)
	ToastMessageShow("Error in Generate_Hash" & CRLF & LastException.Message,True)
	Return 0
End Try
  End Sub
  
  Sub GetFirstInstallTime(Package As String) As Long
   Dim r As Reflector
   r.Target = r.GetContext
   r.Target = r.RunMethod("getPackageManager")
   r.Target = r.RunMethod3("getPackageInfo", Package, "java.lang.String", 0, "java.lang.int")
   Return r.GetField("firstInstallTime")
End Sub

Sub WriteMapToFile(MRoot As String, MDir As String, MFile As String, MP As Map) As Boolean
Try
	If File.ExternalWritable Then
		If File.Exists(MRoot & "/" & MDir, MFile) Then File.Delete(MRoot & "/" & MDir, MFile)
		If File.IsDirectory(MRoot, MDir) Then
			File.WriteMap(MRoot & "/" & MDir, MFile, MP)
			Return True
		Else
			File.MakeDir(MRoot, MDir)
			File.WriteMap(MRoot & "/" & MDir, MFile, MP)
			Return True
		End If
	Else
		Return False
	End If
Catch
	ToastMessageShow(LastException.Message, True)
	Return False
End Try

End Sub

Sub TestMap(MRoot As String, MDir As String, MFile As String, MY As Long) As Long
Dim MP As Map
Dim H As String, Y As String
Try
	If File.ExternalReadable Then
		If File.IsDirectory(MRoot, MDir) Then
			If File.Exists(MRoot & "/" & MDir, MFile) Then
				MP = File.ReadMap(MRoot & "/" & MDir, MFile)
				Y = MP.GetKeyAt(0)
				H = MP.Get(Y)
				If (Y > 0) AND (Y <= MY) Then 
					If H = Generate_Hash(Y) Then
						Return Y
					Else
						Return -1   'File has been tampered with
					End If
				Else
					Return 0
				End If
			Else
				Return 0
			End If
		Else
			Return 0
		End If
	Else
		Return 0
	End If
Catch
	'Log("Error in TestMap: " & LastException.Message)
	ToastMessageShow("Error in TestMap" & CRLF & LastException.Message,True)
	Return 0
End Try

End Sub

'Sub TryUninstall
'Dim i As Intent
'  i.Initialize("android.intent.action.DELETE", "package:" & "com.superlativesoftware.nagtrial")
'  StartActivity(i)
'End Sub


'NOTE! Below should go in paid version to look for this one.
'Sub IsThisPackageNameInstalled(OldPackageName As String ) As Boolean
'Dim pm As PackageManager
'Dim lst As List
'lst.Initialize
'lst=pm.GetInstalledPackages
'Dim str As String
'For i=0 To lst.Size -1
'    str = lst.Get(i)
'    Log (str)
'    If str.CompareTo (OldPackageName)=0 Then Return True
'Next
'Return False
'End Sub

'look up all of our outside items and return the smallest one on a vote if it is less than the install date
Sub GetLeast As Long
Dim S As Long, Y As Long
Dim MyFile As PublicFile
Try
	S =DateTime.DateParse(DateTime.Date(GetFirstInstallTime("com.superlativesoftware.nagtrial")))
	Y = TestMap(File.DirRootExternal, MyFile.DirDownloads,  "Android.Public", S)
	If Y > 0 Then
		If Y < S Then S = Y
	End If
	Y = TestMap(File.DirRootExternal, MyFile.DirDocuments, "Android.DONOTDELETE.Doc", S)
	If Y > 0 Then
		If Y < S Then S = Y
	End If
	Y = TestMap(File.DirRootExternal, MyFile.DirDCIM, "Android.System.sav", S)
	If Y > 0 Then
		If Y < S Then S = Y
	End If
	Y = TestMap(File.DirRootExternal, MyFile.DirMovies, "Andro.sys.bin", S)
	If Y > 0 Then
		If Y < S Then S = Y
	End If
	Return S
Catch
	'Log("Error in GetLeast: " & LastException.Message)
	ToastMessageShow("Error in GetLeast" & CRLF & LastException.Message,True)
	Return S
End Try

End Sub

'10/5/14  End of Trial only